#! Flux3D 12.0

import fluxTool

# Remplacer le formateur de double, limiter le nombre de chiffres
df2 = session.supervisor.getFormaterBuilder().buildIngineerFormaterWithConstantSize(4)
session.supervisor.getFormaterBuilder().setExportFormater(df2)
     
macroPath= fluxTool.getRelativeMacroPath('Macros_Flux3D_Postproc/MetallurgicComputation3D.PFM')
loadMacro(fileName=macroPath)

MetallurgicComputation3D(scenario_anim=Scenario['HEATING_PROCESS'],
                         regionvol=RegionVolume['BILLET'],
                         genericName='Field',
                         Ac1=736.0,
                         Ac3=850.0,
                         Tau_1=1.0,
                         Tau_3=0.026,
                         Ms=400.0,
                         ALPHA=0.02)

lastInstance = IsovalueSpatialGroup(name='ISOVAL_1',
                     formula='tce',
                     forceVisibility='yes',
                     smoothValues='yes',
                     regionInternalExternal='Automatic',
                     internalComputation='no',
                     regionType='volumeRegion',
                     group=[Groupspatial['V_BILLET']])

EvolutiveCurve2D(name='Temperature_Evolution',
                 evolutivePath=EvolutivePath(parameterSet=[SetParameterXVariable(paramEvol=VariationParameter['LINPOS_TRANSLATION'],
                                                                                 limitMin=-0.25,
                                                                                 limitMax=0.5)]),
                 formula=['T_CENTER_EXT',
                          'T_DOWN_EXT',
                          'T_UP_EXT'])

CurveVariation2D['Temperature_Evolution'].exportTXT(txtFile='result/TestCase_RES.txt',
                                     mode='REPLACE FILE')
     

saveProjectAs('postprocessed.FLU')

